//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}


int main()
{
  list<int> coll1;

  INSERT_ELEMENTS(coll1,1,6);
  INSERT_ELEMENTS(coll1,1,9);
  PRINT_ELEMENTS(coll1," :\n");

  //        3
  cout <<ToRus("       3:\n");
  remove_copy(coll1.begin(), coll1.end(),       // 
              ostream_iterator<int>(cout," "),  // 
              3);                               //  
  cout << endl;

  //       ,  4
  cout <<ToRus("      ,  4:\n");
  remove_copy_if(coll1.begin(), coll1.end(),      // 
                 ostream_iterator<int>(cout," "), // 
                 bind2nd(greater<int>(),4));      //  
  cout << endl;

  //   ,  3,  
  multiset<int> coll2;
  remove_copy_if(coll1.begin(), coll1.end(),    // 
                 inserter(coll2,coll2.end()),   // 
                 bind2nd(less<int>(),4));       //  
  PRINT_ELEMENTS(coll2," 2:\n");


  getch();
  return 0;
}

//---------------------------------------------------------------------------